diff --git a/MAINTAINERS b/MAINTAINERS
index fef23a0..4a14945 100644
--- a/MAINTAINERS
+++ b/MAINTAINERS
@@ -427,6 +427,7 @@ Wind River AVP PMD
 M: Allain Legacy <allain.legacy@windriver.com>
 M: Matt Peters <matt.peters@windriver.com>
 F: drivers/net/avp
+F: doc/guides/nics/avp.rst
 
 
 Crypto Drivers
diff --git a/doc/guides/nics/avp.rst b/doc/guides/nics/avp.rst
new file mode 100644
index 0000000..af6d04d
--- /dev/null
+++ b/doc/guides/nics/avp.rst
@@ -0,0 +1,112 @@
+..  BSD LICENSE
+    Copyright(c) 2017 Wind River Systems, Inc. rights reserved.
+    All rights reserved.
+
+    Redistribution and use in source and binary forms, with or without
+    modification, are permitted provided that the following conditions
+    are met:
+
+    * Redistributions of source code must retain the above copyright
+    notice, this list of conditions and the following disclaimer.
+    * Redistributions in binary form must reproduce the above copyright
+    notice, this list of conditions and the following disclaimer in
+    the documentation and/or other materials provided with the
+    distribution.
+    * Neither the name of Intel Corporation nor the names of its
+    contributors may be used to endorse or promote products derived
+    from this software without specific prior written permission.
+
+    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+    "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+    LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
+    A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
+    OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+    SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+    LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+    DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+    (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
+    OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+AVP Poll Mode Driver
+=================================================================
+
+The Accelerated Virtual Port (AVP) device is a shared memory based device
+available on the `virtualization platforms <http://www.windriver.com/products/titanium-cloud/>`_
+from Wind River Systems.  It is based on an earlier implementation of the DPDK
+KNI device and made available to VM instances via a mechanism based on an early
+implementation of qemu-kvm ivshmem.
+
+It enables optimized packet throughput without requiring any packet processing
+in qemu. This provides our customers with a significant performance increase
+for DPDK applications in the VM.  Since our AVP implementation supports VM
+live-migration it is viewed as a better alternative to PCI passthrough or PCI
+SRIOV since neither of those support VM live-migration without manual
+intervention or significant performance penalties.
+
+Since the initial implementation of AVP devices, vhost-user has become
+part of the qemu offering with a significant performance increase over
+the original virtio implementation.  However, vhost-user still does
+not achieve the level of performance that the AVP device can provide
+to our customers for DPDK based VM instances.
+
+The driver binds to PCI devices that are exported by the hypervisor DPDK
+application via the ivshmem-like mechanism.  The definition of the device
+structure and configuration options are defined in rte_avp_common.h and
+rte_avp_fifo.h.  These two header files are made available as part of the PMD
+implementation in order to share the device definitions between the guest
+implementation (i.e., the PMD) and the host implementation (i.e., the
+hypervisor DPDK vswitch application).
+
+
+Features and Limitations of the AVP PMD
+---------------------------------------
+
+The AVP PMD driver provides the following functionality.
+
+*   Receive and transmit of both simple and chained mbuf packets,
+
+*   Chained mbufs may include up to 5 chained segments,
+
+*   Up to 8 receive and transmit queues per device,
+
+*   Only a single MAC address is supported,
+
+*   The MAC address cannot be modified,
+
+*   The maximum receive packet length is 9238 bytes,
+
+*   VLAN header stripping and inserting,
+
+*   Promiscuous mode
+
+*   VM live-migration
+
+*   PCI hotplug insertion and removal
+
+
+Prerequisites
+-------------
+
+The following prerequisites apply:
+
+*   A virtual machine running in a Wind River Systems virtualization
+    environment and configured with at least one neutron port defined with a
+    vif-model set to "avp".
+
+
+Launching a VM with an AVP type network attachment
+--------------------------------------------------
+
+The following example will launch a VM with three network attachments.  The
+first attachment will have a default vif-model of "virtio".  The next two
+network attachments will have a vif-model of "avp" and may be used with a DPDK
+application which is built to include the AVP PMD driver.
+
+.. code-block:: console
+
+    nova boot --flavor small --image my-image \
+       --nic net-id=${NETWORK1_UUID} \
+       --nic net-id=${NETWORK2_UUID},vif-model=avp \
+       --nic net-id=${NETWORK3_UUID},vif-model=avp \
+       --security-group default my-instance1
diff --git a/doc/guides/nics/features/avp.ini b/doc/guides/nics/features/avp.ini
new file mode 100644
index 0000000..64bf42e
--- /dev/null
+++ b/doc/guides/nics/features/avp.ini
@@ -0,0 +1,17 @@
+;
+; Supported features of the 'AVP' network poll mode driver.
+;
+; Refer to default.ini for the full list of available PMD features.
+;
+[Features]
+Link status          = Y
+Queue start/stop     = Y
+Jumbo frame          = Y
+Scattered Rx         = Y
+Promiscuous mode     = Y
+Unicast MAC filter   = Y
+VLAN offload         = Y
+Basic stats          = Y
+Stats per queue      = Y
+Linux UIO            = Y
+x86-64               = Y
diff --git a/doc/guides/nics/index.rst b/doc/guides/nics/index.rst
index 87f9334..0ddcea5 100644
--- a/doc/guides/nics/index.rst
+++ b/doc/guides/nics/index.rst
@@ -36,6 +36,7 @@ Network Interface Controller Drivers
     :numbered:
 
     overview
+    avp
     bnx2x
     bnxt
     cxgbe
diff --git a/doc/guides/rel_notes/release_17_05.rst b/doc/guides/rel_notes/release_17_05.rst
index e25ea9f..3accbac 100644
--- a/doc/guides/rel_notes/release_17_05.rst
+++ b/doc/guides/rel_notes/release_17_05.rst
@@ -41,6 +41,11 @@ New Features
      Also, make sure to start the actual text at the margin.
      =========================================================
 
+* **Added support for the Wind River Systems AVP PMD.**
+
+  Added a new networking driver for the AVP device type. Theses devices are
+  specific to the Wind River Systems virtualization platforms.
+
 
 Resolved Issues
 ---------------